PROGRAM Test_M;

USES Crt, InOut;

CONST
 Version = '02.03.98';


VAR
 Dateiname                : STRING;
 Auswahl                  : BYTE;


PROCEDURE InitOberflaeche;
 BEGIN
  Menu[1,0] := 'Datei';
  Menu[1,1] := 'laden';
  Menu[1,2] := 'speichern';
  Menu[1,3] := '---------------';
  Menu[1,4] := 'Info';
  Menu[1,5] := 'Programmende';

  Menu[2,0] := 'Prozeduren';
  Menu[2,1] := 'Input mit Zeitbegrenzung';

  Menu[3,0] := 'Farbe';
  Menu[3,1] := 'Standard'+ #255;
  Menu[3,2] := 'Extra' + #17;

  Menu[4,0] := '  IO_Test ' + Version;
  InitMenu;
 END; (* InitOberflaeche *)

PROCEDURE FarbModell (Nr: INTEGER);
 BEGIN
  CASE Nr OF
   1: BEGIN
       TA_Normal   := white   + blue  * 16;
       TA_Schatten := black   + blue  * 16;
       TA_Menu     := black   + cyan  * 16;
       TA_Marke    := yellow  + black * 16;
      END;
   2: BEGIN
       TA_Normal   := yellow  + green * 16;
       TA_Schatten := black   + green * 16;
       TA_Menu     := red     + blue  * 16;
       TA_Marke    := cyan    + black * 16;
      END;
  END;
  InitMenu;
 END; (* FarbModell *)

PROCEDURE Speichern;
 BEGIN
   IF StringReq (' Datei speichern ', 'Dateiname: ', 50, DateiName) THEN
    BEGIN
     MausUnsichtbar;
     WriteLn ('Speichern: ', DateiName);
     MausSichtbar;
    END;

 END; (* Speichern *)

PROCEDURE Laden;
 BEGIN
  IF FileReq (DateiName) THEN
   BEGIN
    MausUnsichtbar;
    WriteLn ('Laden: ', DateiName);
    MausSichtbar;
   END;
 END; (* Laden *)


PROCEDURE Input_ZB;
 VAR
  ZeitStr, LoesungsStr  : STRING;
  Zeit, Z1, Z2, Fehler, Loesung  : INTEGER;

 BEGIN
   ZeitStr := '5';
   StringReq ('Zeit', '   t in sec: ', 3, ZeitStr);
   VAL (Zeitstr, Zeit, Fehler);
   IF NOT BooleanReq ('Gleich werde ich Dir eine Aufgabe stellen! Bis Du bereit?',
                      'Nein', 'Ja') THEN EXIT;

   RANDOMIZE;
   Z1 := RANDOM (20) + 1;
   Z2 := RANDOM (20) + 1;
   WRITE (Z1, ' * ', Z2, ' = ');
   LoesungsStr := INPUT ('', 3, - Zeit);
   VAL (LoesungsStr, Loesung, Fehler);
   IF (Fehler = 0) AND (Loesung = Z1 * Z2) THEN
     WRITELN ('Richtig!')
   ELSE
     IF Fehler > 0 THEN
       WRITELN ('Leider zu spt!')
     ELSE
       WRITELN ('Leider falsch!')
  END;  (* Input_ZB *)

PROCEDURE Ende;
 VAR
  IT : InfoTextTyp;
 BEGIN
  IT[01] := 'Wollen Sie wirklich das Programm verlassen?';
  IT[02] := '';

  IF InfoReq (IT, ' Nein ', '  Ja  ') THEN
   ProgrammEnde;
 END; (* Ende*)

PROCEDURE Info;
 VAR
  IT : InfoTextTyp;

 BEGIN
  IT[01] := '      Testprogramm fr die';
  IT[02] := ' ';
  IT[03] := '          UNIT  InOut    ';
  IT[04] := '  ';
  IT[05] := '   Programmversion vom ' + Version;
  IT[06] := '  ';
  IT[07] := '   UNIT-Version vom ' + InOutVersion;
  IT[08] := '  ';
  IT[09] := 'Kurzanleitung:';
  IT[10] := ' ';
  IT[11] := 'Menu aufrufen ...............[ALT]';
  IT[12] := 'Besttigung einer Funktion...[<]';
  IT[13] := 'Abbruch einer Funktion ......[ESC]';
  IT[14] := '';

  IF InfoReq (IT, '', ' Weiter ') THEN
 END; (* Info*)


BEGIN (* IO_Test *)
 InitOberflaeche;
 Info;

 REPEAT
  Auswahl := MenuAuswahl;

  CASE Auswahl OF
   11     : Laden;
   12     : Speichern;
   14     : Info;
   15     : Ende;
   21     : Input_ZB;
   31     : FarbModell (1);
   32     : FarbModell (2);
  END;
 UNTIL FALSE;

END.Test_M
